package ru.dbotthepony.kstarbound.io.json

import com.google.gson.TypeAdapter
import com.google.gson.stream.JsonReader
import com.google.gson.stream.JsonWriter
import ru.dbotthepony.kstarbound.Starbound

class LazyTypeProvider<T : Any?>(private val bound: Class<T>) : TypeAdapter<T>() {
	private val resolved by lazy { Starbound.getTypeAdapter(bound) }

	override fun write(out: JsonWriter, value: T) {
		resolved.write(out, value)
	}

	override fun read(`in`: JsonReader): T {
		return resolved.read(`in`)
	}
}
